#ifndef LATTICE_DDINIT_HEADER_FILE
#define LATTICE_DDINIT_HEADER_FILE
#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

#include "LookupServices.h"
#include "LookupServices.h"
/* platform frequency in MHz */
#define MICO32_CPU_CLOCK_MHZ (25000000)

/*Device-driver structure for lm32_top*/
#define LatticeMico32Ctx_t_DEFINED (1)
typedef struct st_LatticeMico32Ctx_t {
    const char*   name;
} LatticeMico32Ctx_t;


/* lm32_top instance LM32*/
extern struct st_LatticeMico32Ctx_t lm32_top_LM32;

/* declare LM32 instance of lm32_top */
extern void LatticeMico32Init(struct st_LatticeMico32Ctx_t*);


/*Device-driver structure for uart_core*/
#define MicoUartCtx_t_DEFINED (1)
typedef struct st_MicoUartCtx_t {
    const char *   name;
    unsigned int   base;
    unsigned char   intrLevel;
    unsigned char   intrAvail;
    unsigned int   baudrate;
    unsigned int   databits;
    unsigned int   stopbits;
    unsigned char   rxBufferSize;
    unsigned char   txBufferSize;
    unsigned char   blockingTx;
    unsigned char   blockingRx;
    unsigned int   fifoenable;
    unsigned char   *rxBuffer;
    unsigned char   *txBuffer;
    DeviceReg_t   lookupReg;
    unsigned char   rxWriteLoc;
    unsigned char   rxReadLoc;
    unsigned char   txWriteLoc;
    unsigned char   txReadLoc;
    unsigned int   timeoutMicroSecs;
    volatile unsigned char   txDataBytes;
    volatile unsigned char   rxDataBytes;
    unsigned int   errors;
    unsigned char   ier;
    void *   prev;
    void *   next;
} MicoUartCtx_t;


/* uart_core instance uart*/
extern struct st_MicoUartCtx_t uart_core_uart;

/* declare uart instance of uart_core */
extern void MicoUartInit(struct st_MicoUartCtx_t*);


/*Device-driver structure for spi_flash*/
#define MicoSPIFlashCtx_t_DEFINED (1)
typedef struct st_MicoSPIFlashCtx_t {
    const char*   name;
    unsigned int   memory_base;
    unsigned int   memory_size;
    unsigned int   memory_wbSize;
    unsigned int   control_base;
    unsigned int   control_port;
    unsigned int   control_wbSize;
    unsigned int   program_buf_en;
    unsigned int   read_buf_en;
    unsigned int   page_size;
    unsigned int   sector_size;
    DeviceReg_t   lookupReg;
    void *   prev;
    void *   next;
} MicoSPIFlashCtx_t;


/* spi_flash instance SPIFlash*/
extern struct st_MicoSPIFlashCtx_t spi_flash_SPIFlash;

/* declare SPIFlash instance of spi_flash */
extern void MicoSPIFlash_Initialize(struct st_MicoSPIFlashCtx_t*);

extern int main();



#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif
